Index: doc/manual.html
===================================================================
RCS file: /cvsroot/keitairc/doc/manual.html,v
retrieving revision 1.12
retrieving revision 1.13
diff -u -r1.12 -r1.13
--- doc/manual.html	24 Sep 2009 14:33:51 -0000	1.12
+++ doc/manual.html	24 Sep 2009 16:17:00 -0000	1.13
@@ -447,12 +447,17 @@
 	携帯端末の位置情報取得機能をもとに、
 	現在位置の住所文字列を取得する際、
 	どの逆ジオコードサーバを利用するか指定します。<br>
-	refits を指定すると
-	http://refits.cgk.affrc.go.jp/tsrv/jp/rgeocode.html
+	finds を指定すると
+	http://www.finds.jp/wsdocs/rgeocode/
 	で提供されているサービスを使用します。<br>
 	google を指定すると http://maps.google.com
 	で提供されているサービスを使用します。<br>
-	デフォルトは refits です。
+	デフォルトは finds です。<br>
+	(なお、
+	http://www.finds.jp/wsdocs/rgeocode/ は以前は
+	http://refits.cgk.affrc.go.jp/tsrv/jp/rgeocode.html
+	で提供されておりました。当時の設定との互換性のため、
+	refits と指定した場合は finds と同じ意味になります)
       </dd>
       <dt>reverse_message</dt>
       <dd>
Index: lib/Keitairc/Config.pm
===================================================================
RCS file: /cvsroot/keitairc/lib/Keitairc/Config.pm,v
retrieving revision 1.34
retrieving revision 1.35
diff -u -r1.34 -r1.35
--- lib/Keitairc/Config.pm	24 Sep 2009 14:48:21 -0000	1.34
+++ lib/Keitairc/Config.pm	24 Sep 2009 16:17:00 -0000	1.35
@@ -1,6 +1,6 @@
 # -*- mode: perl; coding: utf-8 -*-
 # Keitairc::Config
-# $Id: Config.pm,v 1.34 2009/09/24 14:48:21 ishikawa Exp $
+# $Id: Config.pm,v 1.35 2009/09/24 16:17:00 morimoto Exp $
 # $Source: /cvsroot/keitairc/lib/Keitairc/Config.pm,v $
 #
 # Copyright (c) 2008 Jun Morimoto <morimoto@mrmt.net>
@@ -83,7 +83,7 @@
 	$me->mobile_fontsize(-1);
 	$me->url_target('_self');
 	$me->follow_nick(1);
-	$me->rgeocode_server('refits');
+	$me->rgeocode_server('finds');
 	$me->common_header('
 <meta name="Robots" content="noindex,nofollow" />
 <meta name="Keywords" content="norobot" />
Index: lib/plugins/00location_receiver
===================================================================
RCS file: /cvsroot/keitairc/lib/plugins/00location_receiver,v
retrieving revision 1.14
retrieving revision 1.16
diff -u -r1.14 -r1.16
--- lib/plugins/00location_receiver	28 Dec 2008 15:26:03 -0000	1.14
+++ lib/plugins/00location_receiver	25 Sep 2009 15:05:48 -0000	1.16
@@ -1,7 +1,7 @@
 # -*- mode: perl; coding: utf-8 -*-
 # keitairc/lib/plugins/00location_receiver
 # 位置情報送信、のコールバック
-# $Id: 00location_receiver,v 1.14 2008/12/28 15:26:03 morimoto Exp $
+# $Id: 00location_receiver,v 1.16 2009/09/25 15:05:48 matusita Exp $
 # $Source: /cvsroot/keitairc/lib/plugins/00location_receiver,v $
 #
 # The line number (1 incremented) and filename below must be
@@ -13,11 +13,14 @@
 use Encode;
 
 # refits.cgk.affrc.go.jp を使ってgeocode逆変換
+# ただし 2009 年から www.finds.jp に移転した
+# see http://www.finds.jp/wsdocs/rgeocode/
 # WGS84系を渡すこと
-sub get_rgeocode_refits {
+# と思っていたら「測地系は世界測地系(JGD2000)に基づいています」らしい
+sub get_rgeocode_finds {
 	my ($lat, $lon) = @_;
-	my $s = Net::HTTP->new(Host => 'refits.cgk.affrc.go.jp') || return;
-	$s->write_request(GET => "/tsrv/jp/rgeocode.php?lat=$lat&lon=$lon");
+	my $s = Net::HTTP->new(Host => 'www.finds.jp') || return;
+	$s->write_request(GET => "/ws/rgeocode.php?lat=$lat&lon=$lon");
 	$s->read_response_headers();
 	my $xml_code;
 	for(;;){
@@ -28,12 +31,12 @@
 		$xml_code .= $buf;
 	}
 	my $xml = XMLin($xml_code);
-	if($xml->{status} ne 'true'){
+	if($xml->{status} ne '200'){
 		return;
 	}
-	return $xml->{prefecture}->{pname} .
-		$xml->{municipality}->{mname} .
-		$xml->{local}->{section};
+	return $xml->{result}->{prefecture}->{pname} .
+		$xml->{result}->{municipality}->{mname} .
+		$xml->{result}->{local}->{section};
 }
 
 # maps.google.com を使ってgeocode逆変換
@@ -69,8 +72,9 @@
 
 sub get_rgeocode{
 	my $s;
-	if($::cf->rgeocode_server() eq 'refits'){
-		$s = get_rgeocode_refits(@_);
+	if($::cf->rgeocode_server() eq 'refits' ||
+	   $::cf->rgeocode_server() eq 'finds'){
+		$s = get_rgeocode_finds(@_);
 	}elsif($::cf->rgeocode_server() eq 'google'){
 		$s = get_rgeocode_google(@_);
 	}else{